Index: .gitignore
===================================================================
--- .gitignore	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ .gitignore	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -442,3 +442,2 @@
 tools/gcc-*.tar.bz2
 tools/gdb-*.tar.gz
-tools/sycek/
Index: Makefile
===================================================================
--- Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -30,5 +30,4 @@
 .NOTPARALLEL:
 
-CCHECK = tools/sycek/ccheck
 CSCOPE = cscope
 FORMAT = clang-format
@@ -45,13 +44,11 @@
 CONFIG_MAKEFILE = Makefile.config
 CONFIG_HEADER = config.h
-ERRNO_HEADER = abi/include/abi/errno.h
-ERRNO_INPUT = abi/include/abi/errno.in
 
-.PHONY: all precheck cscope cscope_parts autotool config_auto config_default config distclean clean check releasefile release common boot kernel uspace export-posix
+.PHONY: all precheck cscope cscope_parts autotool config_auto config_default config distclean clean check releasefile release common boot kernel uspace
 
 all: kernel uspace
 	$(MAKE) -r -C boot PRECHECK=$(PRECHECK)
 
-common: $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER) $(ERRNO_HEADER)
+common: $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER)
 
 kernel: common
@@ -60,11 +57,4 @@
 uspace: common
 	$(MAKE) -r -C uspace PRECHECK=$(PRECHECK)
-
-export-posix: common
-ifndef EXPORT_DIR
-	@echo ERROR: Variable EXPORT_DIR is not defined. && false
-else
-	$(MAKE) -r -C uspace export EXPORT_DIR=$(abspath $(EXPORT_DIR))
-endif
 
 precheck: clean
@@ -83,13 +73,4 @@
 	find abi kernel boot uspace -type f -regex '^.*\.[ch]$$' | xargs $(FORMAT) -i -sort-includes -style=file
 
-ccheck: $(CCHECK)
-	tools/ccheck.sh
-
-ccheck-fix: $(CCHECK)
-	tools/ccheck.sh --fix
-
-$(CCHECK):
-	cd tools && ./build-ccheck.sh
-
 doxy:
 	$(MAKE) -r -C doxygen
@@ -102,11 +83,4 @@
 	$(CHECK)
 endif
-
-# `sed` pulls a list of "compatibility-only" error codes from `errno.in`,
-# the following grep finds instances of those error codes in HelenOS code.
-check_errno:
-	@ ! cat abi/include/abi/errno.in | \
-	sed -n -e '1,/COMPAT_START/d' -e 's/__errno_entry(\([A-Z0-9]\+\).*/\\b\1\\b/p' | \
-	git grep -n -f - -- ':(exclude)abi' ':(exclude)uspace/lib/posix'
 
 # Autotool (detects compiler features)
@@ -151,8 +125,3 @@
 	$(MAKE) -r -C doxygen clean
 
-$(ERRNO_HEADER): $(ERRNO_INPUT)
-	echo '/* Generated file. Edit errno.in instead. */' > $@.new
-	sed 's/__errno_entry(\([^,]*\),\([^,]*\),.*/#define \1 __errno_t(\2)/' < $< >> $@.new
-	mv $@.new $@
-
 -include Makefile.local
Index: abi/include/abi/errno.h
===================================================================
--- abi/include/abi/errno.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ abi/include/abi/errno.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -1,117 +1,110 @@
-/* Generated file. Edit errno.in instead. */
-#define EOK             __errno_t(      0)
-#define ENOENT          __errno_t(      1)
-#define ENOMEM          __errno_t(      2)
-#define ELIMIT          __errno_t(      3)
-#define EREFUSED        __errno_t(      4)
-#define EFORWARD        __errno_t(      5)
-#define EPERM           __errno_t(      6)
-#define EHANGUP         __errno_t(      7)
-#define EPARTY          __errno_t(      8)
-#define EEXIST          __errno_t(      9)
-#define EBADMEM         __errno_t(     10)
-#define ENOTSUP         __errno_t(     11)
-#define EADDRNOTAVAIL   __errno_t(     12)
-#define ETIMEOUT        __errno_t(     13)
-#define EINVAL          __errno_t(     14)
-#define EBUSY           __errno_t(     15)
-#define EOVERFLOW       __errno_t(     16)
-#define EINTR           __errno_t(     17)
-#define EMFILE          __errno_t(     18)
-#define ENAMETOOLONG    __errno_t(     19)
-#define EISDIR          __errno_t(     20)
-#define ENOTDIR         __errno_t(     21)
-#define ENOSPC          __errno_t(     22)
-#define ENOTEMPTY       __errno_t(     23)
-#define EBADF           __errno_t(     24)
-#define EDOM            __errno_t(     25)
-#define ERANGE          __errno_t(     26)
-#define EXDEV           __errno_t(     27)
-#define EIO             __errno_t(     28)
-#define EMLINK          __errno_t(     29)
-#define ENXIO           __errno_t(     30)
-#define ENOFS           __errno_t(     31)
-#define EBADCHECKSUM    __errno_t(     32)
-#define ESTALL          __errno_t(     33)
-#define EEMPTY          __errno_t(     34)
-#define ENAK            __errno_t(     35)
-#define EAGAIN          __errno_t(     36)
+/*
+ * Copyright (c) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
 
-/* libhttp error codes. Defining them here is a temporary hack. */
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
 
-#define HTTP_EMULTIPLE_HEADERS  __errno_t(  50)
-#define HTTP_EMISSING_HEADER    __errno_t(  51)
-#define HTTP_EPARSE             __errno_t(  52)
+#ifndef ABI_ERRNO_H_
+#define ABI_ERRNO_H_
 
-/* libext4 error codes. Same as above. */
+/**
+ * Values in the range [-1, -255] are kernel error codes,
+ * values in the range [-256, -512] are user error codes.
+ */
 
-#define EXT4_ERR_BAD_DX_DIR     __errno_t(  60)
+typedef enum {
+	EOK           =  0,   /* No error */
+	ENOENT        = -1,   /* No such entry */
+	ENOMEM        = -2,   /* Not enough memory */
+	ELIMIT        = -3,   /* Limit exceeded */
+	EREFUSED      = -4,   /* Connection refused */
+	EFORWARD      = -5,   /* Forward error */
+	EPERM         = -6,   /* Permission denied */
+
+/*
+ * Answerbox closed connection, call
+ * sys_ipc_hangup() to close the connection.
+ * Used by answerbox to close the connection.
+ */
+	EHANGUP       = -7,
+
+/*
+ * The other party encountered an error when
+ * receiving the call.
+ */
+	EPARTY        = -8,
+
+	EEXIST        = -9,   /* Entry already exists */
+	EBADMEM       = -10,  /* Bad memory pointer */
+	ENOTSUP       = -11,  /* Not supported */
+	EADDRNOTAVAIL = -12,  /* Address not available. */
+	ETIMEOUT      = -13,  /* Timeout expired */
+	EINVAL        = -14,  /* Invalid value */
+	EBUSY         = -15,  /* Resource is busy */
+	EOVERFLOW     = -16,  /* The result does not fit its size. */
+	EINTR         = -17,  /* Operation was interrupted. */
+
+	EMFILE        = -18,
+	ENAMETOOLONG  = -256,
+	EISDIR        = -257,
+	ENOTDIR       = -258,
+	ENOSPC        = -259,
+	ENOTEMPTY     = -261,
+	EBADF         = -262,
+	EDOM          = -263,
+	ERANGE        = -264,
+	EXDEV         = -265,
+	EIO           = -266,
+	EMLINK        = -267,
+	ENXIO         = -268,
+	ENOFS         = -269,
+
+/** Bad checksum. */
+	EBADCHECKSUM  = -300,
+
+/** USB: stalled operation. */
+	ESTALL        = -301,
+
+/** Empty resource (no data). */
+	EEMPTY        = -302,
+
+/** Negative acknowledgment. */
+	ENAK          = -303,
+
+/** The requested operation was not performed. Try again later. */
+	EAGAIN        = -11002,
+} errno_t;
 
 
-/* POSIX error codes + whatever nonstandard names crop up in third-party
- * software. These are not used in HelenOS code, but are defined here in
- * order to avoid nasty hacks in libposix.
- *
- * If you decide to use one of these in native HelenOS code,
- * move it up to the first group.
+#endif
+
+/** @}
  */
-
-/* COMPAT_START -- do not remove or edit this comment */
-
-#define E2BIG             __errno_t(  101)
-#define EACCES            __errno_t(  102)
-#define EADDRINUSE        __errno_t(  103)
-#define EAFNOSUPPORT      __errno_t(  105)
-#define EALREADY          __errno_t(  107)
-#define EBADMSG           __errno_t(  109)
-#define ECANCELED         __errno_t(  111)
-#define ECHILD            __errno_t(  112)
-#define ECONNABORTED      __errno_t(  113)
-#define ECONNREFUSED      __errno_t(  114)
-#define ECONNRESET        __errno_t(  115)
-#define EDEADLK           __errno_t(  116)
-#define EDESTADDRREQ      __errno_t(  117)
-#define EDQUOT            __errno_t(  119)
-#define EFAULT            __errno_t(  121)
-#define EFBIG             __errno_t(  122)
-#define EHOSTUNREACH      __errno_t(  123)
-#define EIDRM             __errno_t(  124)
-#define EILSEQ            __errno_t(  125)
-#define EINPROGRESS       __errno_t(  126)
-#define EISCONN           __errno_t(  130)
-#define ELOOP             __errno_t(  132)
-#define EMSGSIZE          __errno_t(  135)
-#define EMULTIHOP         __errno_t(  136)
-#define ENETDOWN          __errno_t(  138)
-#define ENETRESET         __errno_t(  139)
-#define ENETUNREACH       __errno_t(  140)
-#define ENFILE            __errno_t(  141)
-#define ENOBUFS           __errno_t(  142)
-#define ENODATA           __errno_t(  143)
-#define ENODEV            __errno_t(  144)
-#define ENOEXEC           __errno_t(  146)
-#define ENOLCK            __errno_t(  147)
-#define ENOLINK           __errno_t(  148)
-#define ENOMSG            __errno_t(  150)
-#define ENOPROTOOPT       __errno_t(  151)
-#define ENOSR             __errno_t(  153)
-#define ENOSTR            __errno_t(  154)
-#define ENOSYS            __errno_t(  155)
-#define ENOTCONN          __errno_t(  156)
-#define ENOTRECOVERABLE   __errno_t(  159)
-#define ENOTSOCK          __errno_t(  160)
-#define ENOTTY            __errno_t(  162)
-#define EOPNOTSUPP        __errno_t(  164)
-#define EOWNERDEAD        __errno_t(  166)
-#define EPIPE             __errno_t(  168)
-#define EPROTO            __errno_t(  169)
-#define EPROTONOSUPPORT   __errno_t(  170)
-#define EPROTOTYPE        __errno_t(  171)
-#define EROFS             __errno_t(  173)
-#define ESPIPE            __errno_t(  174)
-#define ESRCH             __errno_t(  175)
-#define ESTALE            __errno_t(  176)
-#define ETIME             __errno_t(  177)
-#define ETIMEDOUT         __errno_t(  178)
-#define ETXTBSY           __errno_t(  179)
-#define EWOULDBLOCK       __errno_t(  180)
Index: abi/include/abi/ipc/ipc.h
===================================================================
--- abi/include/abi/ipc/ipc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ abi/include/abi/ipc/ipc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -60,7 +60,4 @@
 #define IPC_CALL_NOTIF           (1 << 3)
 
-/** The call was automatically answered by the kernel due to error */
-#define IPC_CALL_AUTO_REPLY      (1 << 4)
-
 /**
  * Maximum buffer size allowed for IPC_M_DATA_WRITE and
@@ -70,5 +67,5 @@
 
 /* Macros for manipulating calling data */
-#define IPC_SET_RETVAL(data, retval)  ((data).args[0] = (sysarg_t) (retval))
+#define IPC_SET_RETVAL(data, retval)  ((data).args[0] = (retval))
 #define IPC_SET_IMETHOD(data, val)    ((data).args[0] = (val))
 #define IPC_SET_ARG1(data, val)       ((data).args[1] = (val))
@@ -79,5 +76,5 @@
 
 #define IPC_GET_IMETHOD(data)  ((data).args[0])
-#define IPC_GET_RETVAL(data)   ((errno_t) (data).args[0])
+#define IPC_GET_RETVAL(data)   ((data).args[0])
 
 #define IPC_GET_ARG1(data)  ((data).args[1])
Index: abi/include/abi/synch.h
===================================================================
--- abi/include/abi/synch.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ abi/include/abi/synch.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,4 +46,21 @@
 #define SYNCH_FLAGS_INTERRUPTIBLE  (1 << 1)
 
+/** Could not satisfy the request without going to sleep. */
+#define ESYNCH_WOULD_BLOCK  1
+/** Timeout occurred. */
+#define ESYNCH_TIMEOUT      2
+/** Sleep was interrupted. */
+#define ESYNCH_INTERRUPTED  4
+/** Operation succeeded without sleeping. */
+#define ESYNCH_OK_ATOMIC    8
+/** Operation succeeded and did sleep. */
+#define ESYNCH_OK_BLOCKED   16
+
+#define SYNCH_FAILED(rc) \
+	((rc) & (ESYNCH_WOULD_BLOCK | ESYNCH_TIMEOUT | ESYNCH_INTERRUPTED))
+
+#define SYNCH_OK(rc) \
+	((rc) & (ESYNCH_OK_ATOMIC | ESYNCH_OK_BLOCKED))
+
 #endif
 
Index: boot/generic/include/printf.h
===================================================================
--- boot/generic/include/printf.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ boot/generic/include/printf.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 extern int puts(const char *);
 extern int printf(const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+    PRINTF_ATTRIBUTE(1, 2);
 extern int vprintf(const char *, va_list);
 
Index: boot/generic/include/printf_verify.h
===================================================================
--- boot/generic/include/printf_verify.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ boot/generic/include/printf_verify.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -33,14 +33,14 @@
 #define BOOT_PRINTF_VERIFY_H_
 
-#ifndef _HELENOS_NVERIFY_PRINTF
+#ifndef NVERIFY_PRINTF
 
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end) \
+#define PRINTF_ATTRIBUTE(start, end) \
 	__attribute__((format(gnu_printf, start, end)))
 
-#else /* _HELENOS_NVERIFY_PRINTF */
+#else /* NVERIFY_PRINTF */
 
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end)
+#define PRINTF_ATTRIBUTE(start, end)
 
-#endif /* _HELENOS_NVERIFY_PRINTF */
+#endif /* NVERIFY_PRINTF */
 
 #endif
Index: contrib/arch/uspace/srv/vfs/vfs.bp
===================================================================
--- contrib/arch/uspace/srv/vfs/vfs.bp	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ contrib/arch/uspace/srv/vfs/vfs.bp	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -129,9 +129,9 @@
 	?fstat {
 		tentative {
-			?ipc_m_data_read /* vfs_stat_t */ {
+			?ipc_m_data_read /* struct stat */ {
 				alternative (fs; tmpfs; fat; devfs) {
 					[fnc.vfs_grab_phone] ;
 					!fs.stat {
-						!fs.ipc_m_data_read /* forward vfs_stat_t */
+						!fs.ipc_m_data_read /* forward struct stat */
 					} ;
 					[fnc.vfs_release_phone]
@@ -144,10 +144,10 @@
 		?ipc_m_data_write /* path */ ;
 		tentative {
-			?ipc_m_data_read /* vfs_stat_t */ {
+			?ipc_m_data_read /* struct stat */ {
 				alternative (fs; tmpfs; fat; devfs) {
 					[fnc.vfs_lookup_internal] ;
 					tentative {
 						!fs.stat {
-							!fs.ipc_m_data_read /* forward vfs_stat_t */
+							!fs.ipc_m_data_read /* forward struct stat */
 						}
 					}
Index: contrib/qemu/build-from-scratch.sh
===================================================================
--- contrib/qemu/build-from-scratch.sh	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ contrib/qemu/build-from-scratch.sh	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -29,5 +29,5 @@
 #
 
-VERSION=2.11.0
+VERSION=2.10.0
 BASENAME=qemu-${VERSION}
 BASENAME_MASTER=qemu-master
@@ -36,5 +36,5 @@
 URL=http://wiki.qemu-project.org/download/${TARBALL}
 REPO=git://git.qemu.org/qemu.git
-MD5="335994a755bc655e88a87aeb36bfc0b9"
+MD5="ca73441de73a9b52c6c49c97190d2185"
 
 OPENSPARC_TARBALL="OpenSPARCT1_Arch.1.5.tar.bz2"
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -90,5 +90,5 @@
 
 COMMON_CFLAGS = $(INCLUDES_FLAGS) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-ffreestanding -nostdlib -nostdinc \
+	-ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-fexec-charset=UTF-8 -finput-charset=UTF-8 -fno-common \
 	-fdebug-prefix-map=$(realpath $(ROOT_PATH))=.
@@ -208,10 +208,9 @@
 	generic/src/mm/backend_user.c \
 	generic/src/mm/slab.c \
-	generic/src/lib/halt.c \
+	generic/src/lib/func.c \
 	generic/src/lib/mem.c \
 	generic/src/lib/memfnc.c \
 	generic/src/lib/gsort.c \
 	generic/src/lib/str.c \
-	generic/src/lib/str_error.c \
 	generic/src/lib/elf.c \
 	generic/src/lib/ra.c \
Index: kernel/arch/abs32le/include/arch/mm/as.h
===================================================================
--- kernel/arch/abs32le/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/abs32le/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,7 +48,7 @@
 #include <genarch/mm/as_pt.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)  (as != as)
+#define as_destructor_arch(as)          (as != as)
+#define as_create_arch(as, flags)       (as != as)
 #define as_install_arch(as)
 #define as_deinstall_arch(as)
Index: kernel/arch/abs32le/src/abs32le.c
===================================================================
--- kernel/arch/abs32le/src/abs32le.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/abs32le/src/abs32le.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <arch/asm.h>
 
-#include <halt.h>
+#include <func.h>
 #include <config.h>
 #include <console/console.h>
@@ -105,5 +105,5 @@
 int context_save_arch(context_t *ctx)
 {
-	return EOK;
+	return 1;
 }
 
@@ -125,10 +125,10 @@
 }
 
-errno_t memcpy_from_uspace(void *dst, const void *uspace_src, size_t size)
+int memcpy_from_uspace(void *dst, const void *uspace_src, size_t size)
 {
 	return EOK;
 }
 
-errno_t memcpy_to_uspace(void *uspace_dst, const void *src, size_t size)
+int memcpy_to_uspace(void *uspace_dst, const void *src, size_t size)
 {
 	return EOK;
Index: kernel/arch/abs32le/src/mm/page.c
===================================================================
--- kernel/arch/abs32le/src/mm/page.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/abs32le/src/mm/page.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <align.h>
 #include <config.h>
-#include <halt.h>
+#include <func.h>
 #include <arch/interrupt.h>
 #include <arch/asm.h>
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/amd64/Makefile.inc	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -32,5 +32,5 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-COMMON_CFLAGS += -mcmodel=$(MEMORY_MODEL) -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
+COMMON_CFLAGS += -m64 -mcmodel=$(MEMORY_MODEL) -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
 
 BITS = 64
Index: kernel/arch/amd64/include/arch/mm/as.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/amd64/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,7 +46,7 @@
 #define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0x00007fffffffffff)
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)  (as != as)
+#define as_destructor_arch(as)          (as != as)
+#define as_create_arch(as, flags)       (as != as)
 
 #define as_install_arch(as)
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/amd64/src/interrupt.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include <panic.h>
 #include <arch/drivers/i8259.h>
-#include <halt.h>
+#include <func.h>
 #include <cpu.h>
 #include <arch/asm.h>
Index: kernel/arch/arm32/include/arch/cache.h
===================================================================
--- kernel/arch/arm32/include/arch/cache.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/arm32/include/arch/cache.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,10 +39,10 @@
 #include <typedefs.h>
 
-extern unsigned dcache_levels(void);
+unsigned dcache_levels(void);
 
-extern void dcache_flush(void);
-extern void dcache_flush_invalidate(void);
-extern void cpu_dcache_flush(void);
-extern void cpu_dcache_flush_invalidate(void);
+void dcache_flush(void);
+void dcache_flush_invalidate(void);
+void cpu_dcache_flush(void);
+void cpu_dcache_flush_invalidate(void);
 extern void icache_invalidate(void);
 extern void dcache_invalidate(void);
@@ -50,5 +50,5 @@
 
 #endif
-
 /** @}
  */
+
Index: kernel/arch/arm32/include/arch/mm/as.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/arm32/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,7 +49,7 @@
 #include <genarch/mm/as_pt.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)		(as != as)
+#define as_destructor_arch(as)			(as != as)
+#define as_create_arch(as, flags)		(as != as)
 #define as_deinstall_arch(as)
 #define as_invalidate_translation_cache(as, page, cnt)
Index: kernel/arch/arm32/src/mach/beaglebone/beaglebone.c
===================================================================
--- kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -123,5 +123,5 @@
 {
 	unsigned sysclk_freq;
-	errno_t rc;
+	int rc;
 
 	/* Initialize the IRQ */
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia32/Makefile.inc	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,5 @@
 ENDIANESS = LE
 
-COMMON_CFLAGS += -fno-omit-frame-pointer
+COMMON_CFLAGS += -m32 -fno-omit-frame-pointer
 
 ## Accepted CPUs
Index: kernel/arch/ia32/include/arch/mm/as.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia32/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,7 +48,7 @@
 #include <genarch/mm/as_pt.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)  (as != as)
+#define as_destructor_arch(as)          (as != as)
+#define as_create_arch(as, flags)       (as != as)
 #define as_install_arch(as)
 #define as_deinstall_arch(as)
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia32/src/interrupt.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include <panic.h>
 #include <arch/drivers/i8259.h>
-#include <halt.h>
+#include <func.h>
 #include <cpu.h>
 #include <arch/asm.h>
Index: kernel/arch/ia32/src/mm/page.c
===================================================================
--- kernel/arch/ia32/src/mm/page.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia32/src/mm/page.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 #include <align.h>
 #include <config.h>
-#include <halt.h>
+#include <func.h>
 #include <arch/interrupt.h>
 #include <arch/asm.h>
Index: kernel/arch/ia32/src/smp/mps.c
===================================================================
--- kernel/arch/ia32/src/smp/mps.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia32/src/smp/mps.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <arch/smp/smp.h>
 #include <assert.h>
-#include <halt.h>
+#include <func.h>
 #include <typedefs.h>
 #include <cpu.h>
@@ -91,5 +91,5 @@
 		return false;
 	
-	return ((processor_entries[i].cpu_flags & 0x01) == 0x01);
+	return (bool) ((processor_entries[i].cpu_flags & 0x01) == 0x01);
 }
 
@@ -98,5 +98,5 @@
 	assert(i < processor_entry_cnt);
 	
-	return ((processor_entries[i].cpu_flags & 0x02) == 0x02);
+	return (bool) ((processor_entries[i].cpu_flags & 0x02) == 0x02);
 }
 
Index: kernel/arch/ia32/src/smp/smp.c
===================================================================
--- kernel/arch/ia32/src/smp/smp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia32/src/smp/smp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,4 @@
 #include <arch/boot/boot.h>
 #include <assert.h>
-#include <errno.h>
 #include <genarch/acpi/acpi.h>
 #include <genarch/acpi/madt.h>
@@ -45,5 +44,5 @@
 #include <synch/waitq.h>
 #include <arch/pm.h>
-#include <halt.h>
+#include <func.h>
 #include <panic.h>
 #include <arch/asm.h>
@@ -179,5 +178,5 @@
 			 */
 			if (waitq_sleep_timeout(&ap_completion_wq, 1000000,
-			    SYNCH_FLAGS_NONE, NULL) == ETIMEOUT) {
+			    SYNCH_FLAGS_NONE) == ESYNCH_TIMEOUT) {
 				log(LF_ARCH, LVL_NOTE, "%s: waiting for cpu%u "
 				    "(APIC ID = %d) timed out", __FUNCTION__,
Index: kernel/arch/ia64/include/arch/mm/as.h
===================================================================
--- kernel/arch/ia64/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia64/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,7 +48,7 @@
 #include <genarch/mm/as_ht.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)  (as != as)
+#define as_destructor_arch(as)          (as != as)
+#define as_create_arch(as, flags)       (as != as)
 #define as_deinstall_arch(as)
 #define as_invalidate_translation_cache(as, page, cnt)
Index: kernel/arch/ia64/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia64/src/ddi/ddi.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ia64/src/ddi/ddi.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,5 +53,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-errno_t ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
+int ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
 	if (!task->arch.iomap) {
@@ -85,5 +85,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-errno_t ddi_iospace_disable_arch(task_t *task, uintptr_t ioaddr, size_t size)
+int ddi_iospace_disable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
 	if (!task->arch.iomap)
Index: kernel/arch/mips32/include/arch/mm/as.h
===================================================================
--- kernel/arch/mips32/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/mips32/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,7 +48,7 @@
 #include <genarch/mm/as_pt.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)		(as != as)
+#define as_destructor_arch(as)			(as != as)
+#define as_create_arch(as, flags)		(as != as)
 #define as_deinstall_arch(as)
 #define as_invalidate_translation_cache(as, page, cnt)
Index: kernel/arch/mips32/src/debugger.c
===================================================================
--- kernel/arch/mips32/src/debugger.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/mips32/src/debugger.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 #include <arch.h>
 #include <arch/cp0.h>
-#include <halt.h>
+#include <func.h>
 #include <symtab.h>
 
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/mips32/src/exception.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 #include <print.h>
 #include <interrupt.h>
-#include <halt.h>
+#include <func.h>
 #include <ddi/irq.h>
 #include <arch/debugger.h>
Index: kernel/arch/ppc32/include/arch/mm/as.h
===================================================================
--- kernel/arch/ppc32/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/ppc32/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,7 +50,7 @@
 #include <genarch/mm/as_pt.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)  (as != as)
+#define as_destructor_arch(as)          (as != as)
+#define as_create_arch(as, flags)       (as != as)
 #define as_deinstall_arch(as)
 
Index: kernel/arch/riscv64/include/arch/mm/as.h
===================================================================
--- kernel/arch/riscv64/include/arch/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/riscv64/include/arch/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,7 +51,7 @@
 #include <genarch/mm/as_pt.h>
 
-#define as_constructor_arch(as, flags)  ((void)as, (void)flags, EOK)
-#define as_destructor_arch(as)          ((void)as, 0)
-#define as_create_arch(as, flags)       ((void)as, (void)flags, EOK)
+#define as_constructor_arch(as, flags)  (as != as)
+#define as_destructor_arch(as)          (as != as)
+#define as_create_arch(as, flags)       (as != as)
 #define as_deinstall_arch(as)
 #define as_invalidate_translation_cache(as, page, cnt)
Index: kernel/arch/riscv64/src/mm/page.c
===================================================================
--- kernel/arch/riscv64/src/mm/page.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/riscv64/src/mm/page.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 #include <align.h>
 #include <config.h>
-#include <halt.h>
+#include <func.h>
 #include <arch/interrupt.h>
 #include <arch/asm.h>
